#!----------------------------------------------------------------------------!
#TEMPLATE (MyTemplateChain,'My custom template chain'),FAMILY('MyTemplate')
#!----------------------------------------------------------------------------!
#SYSTEM
#!---------------------------------------------------------------------
#!---------------------------------------------------------------------
#! Declare your global template variables with #DECLARE
#!---------------------------------------------------------------------
#DECLARE(%SourceFile)
#DECLARE(%GenerateModule)
#DECLARE(%GlobalRegenerate)
#DECLARE(%BuildFile)
#DECLARE(%BuildHeader)
#!---------------------------------------------------------------------
#APPLICATION('Custom application')
#!---------------------------------------------------------------------
#! Do any setup for the global template prompts here. 
#!---------------------------------------------------------------------
#PREPARE
#INSERT(%Trace,'#APPLICATION #PREPARE')
#ENDPREPARE
#SHEET,ADJUST
    #TAB('General')
        #DISPLAY('Add your general settings here')
    #ENDTAB
#ENDSHEET
#!---------------------------------------------------------------------
#! Begin code generation
#!---------------------------------------------------------------------
#!---------------------------------------------------------------------
#! For some reason generation messages don't appear in C7 unless there's 
#! an #ERROR statement at the start. 
#!---------------------------------------------------------------------
#ERROR(' ') 
#INSERT(%Trace,'#APPLICATION begin code generation')
#MESSAGE('Generating ' & %Application & ' global data',1)            #! Open the Message Box
#SET(%BuildFile,UPPER(%Application&'.B1$'))
#SET(%BuildHeader,UPPER(%Application&'.H1$'))
#INSERT(%Trace,'%Generating')
#IF (%EditProcedure)                                #! Special case for editing embedded source in context
    #INSERT(%Trace,'%Generating ' & %EditFilename & ' for embeditor')
    #CREATE(%EditFilename)
    #FIND(%ModuleProcedure,%EditProcedure)
    #FIX(%Procedure,%ModuleProcedure)                 #! Fix current procedure
    #MESSAGE('Generating Module:    ' & %Module,1)    #! Post generation message
    #MESSAGE('Generating Procedure: ' & %Procedure,2) #! Post generation message
    #GENERATE(%Procedure)                             #! Generate procedure code
    #COMMENT(60)                                      #!Set comment alignment to column 60
    #CLOSE
    #! Terminate code generation if this is just an embed edit
    #ABORT        
#ENDIF
#!---------------------------------------------------------------------
#! This is the standard Clarion approach
#!---------------------------------------------------------------------
#FOR(%Module),WHERE (%Module <> %Program)        #! For all member modules
  #MESSAGE('Generating Module:    '&UPPER(%Module),1) #! Post generation message
  #IF(%GlobalRegenerate OR %ModuleChanged OR ~FILEEXISTS(%Module))
    #SET(%GenerateModule,%True)
  #ELSE
    #SET(%GenerateModule,%False)
  #ENDIF
  #IF(%GenerateModule)                            #! IF module to be generated
    #GENERATE(%Module)
    #COMMENT(60)                                  #! Set comment alignment to column 60
  #ENDIF                                          #! END (If module to be...)
#ENDFOR     
#!---------------------------------------------------------------------
#! Generate the procedures
#!---------------------------------------------------------------------
#!#FOR(%Module),WHERE (%Module <> %Program) 
#!    #INSERT(%Trace,'Checking module ' & %Module)
#!    #IF(%ModuleChanged)
#!        #INSERT(%Trace,'Module has changed, generating')
#!        #FOR(%ModuleProcedure)
#!            #FIX(%Procedure,%ModuleProcedure)
#!            #MESSAGE('Generating ' & %Procedure,2)        
#!            #SET(%SourceFile,%Application & '.' & %Procedure & '.txt')
#!            #INSERT(%Trace,'Creating file ' & %SourceFile)
#!            #CREATE(%SourceFile)
#!            #GENERATE(%Procedure)
#!            #CLOSE(%SourceFile)
#!        #ENDFOR
#!    #ELSE
#!        #INSERT(%Trace,'Module unchanged, not generating')
#!    #ENDIF
#!#ENDFOR
#!---------------------------------------------------------------------
#! End code generation
#!---------------------------------------------------------------------
#!---------------------------------------------------------------------
#! Includes
#!---------------------------------------------------------------------
#INCLUDE('my_standard.tpw')
#INCLUDE('my_groups.tpw')
#INCLUDE('my_procedures.tpw')